﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Genuilder.Extensibility.Tests
{
	public class MockCodeItem : MemoryCodeItem
	{
		public MockCodeItem(string content, string fileName, CodeItemState initialState)
			: base(content, fileName, initialState)
		{

		}
		public bool Exist
		{
			get;
			set;
		}
		public bool Modified
		{
			get;
			set;
		}
	}
	public class MockCodeRepository : CodeRepositoryBase
	{
		private readonly List<CodeItemHistory> _Histories = new List<CodeItemHistory>();
		public List<CodeItemHistory> Histories
		{
			get
			{
				return _Histories;
			}
		}
		protected override CodeItem CreateCodeItem(string fileName, CodeItemState state)
		{
			return new MockCodeItem("", fileName, state);
		}

		protected override IEnumerable<CodeItemHistory> GetCodeItemHistories()
		{
			return _Histories;
		}
	}
}
