using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SlasheneFramework;
using SlasheneFramework.VisualStudio;
using System.Windows.Shapes;

namespace Genuilder.GUI
{
	public class ProjectViewModel : NotifyPropertyChangedBase
	{
		public ProjectViewModel(Project project)
		{
			_Project = project;
		}

		private readonly Project _Project;
		public Project Project
		{
			get
			{
				return _Project;
			}
		}
		public String Name
		{
			get
			{
				return System.IO.Path.GetFileNameWithoutExtension(_Project.Item.Name);
			}
		}
		private bool _IsSelected;
		public bool IsSelected
		{
			get
			{
				return _IsSelected;
			}
			set
			{
				if(value != _IsSelected)
				{
					_IsSelected = value;
					OnPropertyChanged(() => this.IsSelected);
				}
			}
		}
	}
}
