using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using schemas.microsoft.com.developer.msbuild.Item2003;
using System.IO;

namespace SetCommonConfigOnTargets
{
	public class CommonTargetsFilter : Filter
	{
		#region Filter Members

		public bool Match(System.IO.FileInfo file)
		{
			return file.FullName.EndsWith(".Targets.csproj") || file.FullName.EndsWith("Genuilder.GUI.csproj");
		}

		public void Process(System.IO.FileInfo file)
		{
			var after = "../../../CommonConfig/Common.After.targets";
			var before = "../../../CommonConfig/Common.Before.targets";
			var proj = Project.Load(file.FullName);
			var import = proj.CommonImport;
			bool modified = import.EnsureHasImportToFile(after, file.Directory.FullName, Position.After);
			modified = modified & import.EnsureHasImportToFile(before, file.Directory.FullName, Position.Before);
			if(modified)
				proj.Save(file.FullName);
		}

		#endregion
	}
}
