﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using Genuilder;

namespace PropertiesExtractor.TestProject
{
	[ExtractProperties(typeof(ViewModelProperties))]
	public class ViewModel : INotifyPropertyChanged
	{
		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion

		private String _Label;
		public String Label
		{
			get
			{
				return _Label;
			}
			set
			{
				if(value != _Label)
				{
					_Label = value;
					if(PropertyChanged != null)
						PropertyChanged(this, new PropertyChangedEventArgs(ViewModelProperties.Label));
				}
			}
		}
	}
}
