﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Genuilder.Extensibility.Utilities
{
	public interface IExtensibleObject
	{
		/// <summary>
		/// 
		/// </summary>
		/// <typeparam name="T"></typeparam>
		/// <exception cref="AppConfigVerifier.ExtensionCreationException"></exception>
		/// <returns></returns>
		T GetExtension<T>();
	}

	[global::System.Serializable]
	public class ExtensionCreationException : Exception
	{
		//
		// For guidelines regarding the creation of new exception types, see
		//    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cpgenref/html/cpconerrorraisinghandlingguidelines.asp
		// and
		//    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dncscol/html/csharp07192001.asp
		//

		public ExtensionCreationException()
		{
		}
		public ExtensionCreationException(string message)
			: base(message)
		{
		}
		public ExtensionCreationException(string message, Exception inner)
			: base(message, inner)
		{
		}
		protected ExtensionCreationException(
		  System.Runtime.Serialization.SerializationInfo info,
		  System.Runtime.Serialization.StreamingContext context)
			: base(info, context)
		{
		}
	}
}
