﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.IO;
using System.Xml;
using System.Reflection;

namespace Genuilder.Extensibility.MSBuild
{
	public static class Extensions
	{
		public static string ToXmlValue(this IExtension extension, string fromPath)
		{
			DataContractSerializer serializer = new DataContractSerializer(extension.GetType());
			MemoryStream ms = new MemoryStream();
			var writer = XmlDictionaryWriter.CreateBinaryWriter(ms);
			serializer.WriteObject(writer, extension);
			writer.Flush();
			return extension.GetType().FullName + "|" + PathUtil.RelativePathTo(fromPath, extension.GetType().Assembly.Location) + "|" + Convert.ToBase64String(ms.ToArray());
		}

		public static IExtension ToExtension(this string value, Dictionary<string, Assembly> assemblyCache)
		{
			var split = value.Split('|');
			var typeName = split[0];
			var assemblyPath = split[1];
			var data = split[2];

			Assembly assembly = null;
			if(!File.Exists(assemblyPath))
				throw new FileNotFoundException("It seems you have not compiled your Genuilder Project...\r\nAssembly of Genuilder extension " + typeName + " not found at " + assemblyPath);
			if(!assemblyCache.TryGetValue(assemblyPath, out assembly))
			{
				assembly = Assembly.LoadFrom(assemblyPath);
				assemblyCache.Add(assemblyPath, assembly);
			}
			Type type = assembly.GetType(typeName);

			DataContractSerializer serializer = new DataContractSerializer(type);
			return (IExtension)serializer.ReadObject(XmlDictionaryReader.CreateBinaryReader(Convert.FromBase64String(data), new XmlDictionaryReaderQuotas()));
		}

	}
}
