﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Build.Construction;

namespace Genuilder
{
	public class MSBuildData
	{
		public MSBuildData(Project project)
		{
			_Project = project;
		}
		private readonly Project _Project;
		public Project Project
		{
			get
			{
				return _Project;
			}
		}
		private IEnumerable<ProjectElement> EnumerateNextChildren(ProjectElement element)
		{
			element = element.NextSibling;
			while(element != null)
			{
				var next = element.NextSibling;
				yield return element;
				element = next;
			}
		}
		ProjectImportElement _StartImportGenuilder;
		public ProjectImportElement StartImportGenuilder
		{
			get
			{
				EnsureParse();
				return _StartImportGenuilder;
			}
		}
		ProjectItemGroupElement _EndItemGroupGenuilder;
		public ProjectItemGroupElement EndItemGroupGenuilder
		{
			get
			{
				EnsureParse();
				return _EndItemGroupGenuilder;
			}
		}

		ProjectRootElement _ProjectRootElement;

		public ProjectRootElement ProjectRootElement
		{
			get
			{
				EnsureParse();
				return _ProjectRootElement;
			}
		}
		private ProjectImportElement FindImport(string import)
		{
			//<ItemGroup Condition="'dont touch it !' == 'or bad things will happen'">
			return ProjectRootElement.Imports.FirstOrDefault(i => i.Project == import);
		}

		const string EndConditionString = "'dont touch it !' == 'or bad things will happen'";
		private void EnsureParse()
		{
			if(_ProjectRootElement == null)
			{
				_ProjectRootElement = ProjectRootElement.Open(_Project.Path);
				_StartImportGenuilder = FindImport("StartGenuilder");
				_EndItemGroupGenuilder = FindItemGroup(EndConditionString);
				if(_StartImportGenuilder != null)
				{
					UnInstallFeatures();
				}

				if(_StartImportGenuilder == null)
				{
					_StartImportGenuilder = ProjectRootElement.AddImport("StartGenuilder");
					_StartImportGenuilder.Condition = "'Genuilder internal dont touch  or apocalypse will come' == 'true'";
				}

				if(_EndItemGroupGenuilder == null)
				{
					_EndItemGroupGenuilder = ProjectRootElement.AddItemGroup().After(StartImportGenuilder);
					_EndItemGroupGenuilder.Condition = EndConditionString;
				}
				if(!Project.UseHostCompilerIfAvailable)
				{
					_ProjectRootElement
						.AddPropertyGroup()
						.After(_StartImportGenuilder)
						.AddProperty("UseHostCompilerIfAvailable", "false");
				}
			}
		}

		private ProjectItemGroupElement FindItemGroup(string condition)
		{
			return ProjectRootElement.ItemGroups.FirstOrDefault(i => i.Condition == condition);
		}

		internal void UnInstallFeatures()
		{
			foreach(var element in EnumerateNextChildren(StartImportGenuilder))
			{
				if(element == EndItemGroupGenuilder)
					break;
				element.Parent.RemoveChild(element);
			}
		}
	}
}
